#include <EEPROM.h>
#include <Tic.h>
TicI2C tic;
const int DIN_PIN_7 = 7;
const int DIN_PIN_6 = 6;
const int DIN_PIN_5 = 5;
int latched;
int last_latched;
int value;
int a = 0;
int disp = 0;
int trblsht = 0;

// Define the current limit, in milliamps, to use while moving
// the motor.
const uint16_t currentLimitWhileMoving = 600;

// Define the current limit, in milliamps, to use while stopped.
const uint16_t currentLimitWhileStopped = 600;
    




void setup()
{
    pinMode( DIN_PIN_7, 7 );
    pinMode( DIN_PIN_6, 6 );
    pinMode( DIN_PIN_5, 5 );
    value = EEPROM.read(a);
     tic.setProduct(TicProduct::T825);    //int disp;
    last_latched = value;
    //disp = 0;
    Serial.begin( 9600 );
    Serial.println( "*** SETUP ***" );
    Serial.println( last_latched );
    latched = 0;

  // Set up I2C.
  Wire.begin();


  
  // Give the Tic some time to start up.
  delay(20);

  // Set the Tic's current position to 0, so that when we command
  // it to move later, it will move a predictable amount.
  tic.haltAndSetPosition(0);

  // Tells the Tic that it is OK to start driving the motor.  The
  // Tic's safe-start feature helps avoid unexpected, accidental
  // movement of the motor: if an error happens, the Tic will not
  // drive the motor again until it receives the Exit Safe Start
  // command.  The safe-start feature can be disbled in the Tic
  // Control Center.
  tic.exitSafeStart();
}

// Sends a "Reset command timeout" command to the Tic.  We must
// call this at least once per second, or else a command timeout
// error will happen.  The Tic's default command timeout period
// is 1000 ms, but it can be changed or disabled in the Tic
// Control Center.
void resetCommandTimeout()
{
  tic.resetCommandTimeout();
}

// Delays for the specified number of milliseconds while
// resetting the Tic's command timeout so that its movement does
// not get interrupted by errors.
void delayWhileResettingCommandTimeout(uint32_t ms)
{
  uint32_t start = millis();
  do
  {
    resetCommandTimeout();
  } while ((uint32_t)(millis() - start) <= ms);
}

// Polls the Tic, waiting for it to reach the specified target
// position.  Note that if the Tic detects an error, the Tic will
// probably go into safe-start mode and never reach its target
// position, so this function will loop infinitely.  If that
// happens, you will need to reset your Arduino.
void waitForPosition(int32_t targetPosition)
{
  do
  {
    resetCommandTimeout();
  } while (tic.getCurrentPosition() != targetPosition);
}






void loop(){
    int value7; //neutral
    int value6; //reverse
    int value5; //forward
    //int lached;
    //int disp;


    value7 = digitalRead( DIN_PIN_7 );
    value6 = digitalRead( DIN_PIN_6 );
    value5 = digitalRead( DIN_PIN_5 );

    if ((value7 == 1) && (latched != 7)) {
      Serial.println( "NEUT SWITCH CLOSED" );
      latched = 7;
      disp = 0;
      delay(20);
    }
    
    if ((value6 == 1) && (latched != 6)) {
      Serial.println( "REV SWITCH CLOSED" );
      latched = 6;
      disp = 0;
      delay(20);
    }
    
    if ((value5 == 1) && (latched != 5)) {
      Serial.println( "FWD SWITCH CLOSED" );
      latched = 5;
      disp = 0;
      delay(20);
    }
    //Serial.println( "Value5 =" );
    //Serial.println( value5 );
    //Serial.println( "Value6 =" );
    //Serial.println( value6 );
    //Serial.println( "Value7 =" );
    //Serial.println( value7 );



    if ((latched == 7) && (disp == 0)) {
      if (latched != last_latched) {
        //Serial.println( "LATCHED HAS CHANGED FROM " );
        //Serial.println( last_latched );
        //Serial.println( "TO" );
        //Serial.println( latched );
        //delay(20);
      }
      last_latched = 7;
      disp = 2;
      delay(20);
      //*************************************************
	  if (trblsht == 1) {
		  Serial.println( "MOVE TO NEUTRAL" );
		  delay(90);
		  Serial.println( "SET CURRENT LIM MOVING" );
		  delay(90);
    }
      tic.setCurrentLimit(currentLimitWhileMoving);
      delay(20);
	  if (trblsht == 1) {
		    Serial.println( "MOVE");
		    delay(90);
    }
      tic.setTargetPosition(0);
      delay(20);
	  //waitForPosition(0);
	  if (trblsht == 1) {
		    Serial.println( "NEUT POS ACHIEVED, SET CURRENT LIM STOPPED" );
      	delay(90);
		    Serial.println( "SET CURRENT LIM STOPPED");
		    delay(90);
    }
      tic.setCurrentLimit(currentLimitWhileStopped);
      delay(20);
      //*************************************************
	  if (trblsht == 1) {
		    Serial.println( "DRIVE MODE == NEUTRAL" );
		    Serial.println( " " );
		    delay(90);
    }
      EEPROM.write(0, last_latched);
      delay(50);
      }
    if ((latched == 6) && (disp == 0)) {
      if (latched != last_latched) {
        //Serial.println( "LATCHED HAS CHANGED FROM " );
        //Serial.println( last_latched );
        //Serial.println( "TO" );
        //Serial.println( latched );
        //delay(25);
      }
      last_latched = 6;
      disp = 2;
      delay(20);
      //*************************************************
	  if (trblsht == 1) {
		    Serial.println( "MOVE TO REVERSE" );
        delay(90);
		    Serial.println( "SET CURRENT LIM MOVING" );
		    delay(90);
    }
      tic.setCurrentLimit(currentLimitWhileMoving);
      delay(20);
	  if (trblsht == 1) {
		    Serial.println( "MOVE" );
		    delay(20);
    }
    tic.setTargetPosition(660);
	  //waitForPosition(660);
    delay(20);
	  if (trblsht == 1) {
         Serial.println( "REV POS ACHIEVED, SET CURRENT LIM STOPPED" );
         delay(90);
		    Serial.println( "SET CURRENT LIM STOPPED" );
    }
    tic.setCurrentLimit(currentLimitWhileStopped);  
    delay(20);    
    //*************************************************
	  if (trblsht == 1) {
		    Serial.println( "DRIVE MODE == REVERSE" );
		    Serial.println( " " );
		    delay(90);
    }
      EEPROM.write(0, last_latched);
      delay(50);
    }
    if ((latched == 5) && (disp == 0)) {
      if (latched != last_latched) {
        //Serial.println( "LATCHED HAS CHANGED FROM " );
        //Serial.println( last_latched );
        //Serial.println( "TO" );
        //Serial.println( latched );
        //delay(100);
      }
      last_latched = 5;
      disp = 2;
      delay(20);
      //*************************************************
	  if (trblsht == 1) {
		  Serial.println( "MOVE TO FORWARD" );
		  delay(90);
		  Serial.println( "SET CURRENT LIM MOVING" );
		  delay(90);
    }
    tic.setCurrentLimit(currentLimitWhileMoving);
    delay(20);
	  if (trblsht == 1) {
		    Serial.println( "MOVE" );
		    delay(90);
    }
    tic.setTargetPosition(-600);
    delay(20);
    //Serial.println( "TARGET SET WAIT FOR POS " );
    //waitForPosition(-600);
	  if (trblsht == 1) {
		  Serial.println( "FWD POS ACHIEVED, SET CURRENT LIM STOPPED" );
		  delay(90);
    }
    tic.setCurrentLimit(currentLimitWhileStopped); 
    delay(20);
	  if (trblsht == 1) {
		  Serial.println( "SET CURRENT LIM STOPPED" );
		  delay(90);     
		  //*************************************************
		  Serial.println( "DRIVE MODE == FORWARD" );
		  Serial.println( " " );
		  delay(90);
    }
      EEPROM.write(0, last_latched);
      delay(50);
    }
    if ( disp != 2 ) { 
      disp = 1; 
    } 
//Serial.println( value5 );
//Serial.println( value6 );
//Serial.println( value7 );
    delay(50);
}